### Requirement at a Glance:

- Highly available web app , using the servless offering of aws
- Secure access of Credentials to build Infrastructure.
- Use terraform - with remote state management.
- Web App should reside in a Private Space
- Infra should be scalable to support multiple environments.

### Solution Offering:
- Highly available web app , using the servless offering of aws : Use AWS lambda
- Secure access of Credentials to build Infrastructure: Use Hashicorp Vault to render dynamic aws credentials
- Use terraform - with remote state management : Use S3 to store state files.
- Web App should reside in a Private Space : Mount AWS lambda in a Private Subnet
- Infra should be scalable to support multiple environments: Expose variables that can create different environements , Use terraform modules for scaling components as well as for ease of readability


### High Level Overview
#### Bootstrapping
Repo link : https://gitlab.com/vineethbhargavan/terraform_vault_aws/vault_s3bucket.git
##### Implementation Notes:
- Create Vault Namespace for a fixed environment (say "dev")
- The Namespace will have an aws secret engine which will associate with aws to provide dynamic credentials upon invoked.
- The Namespace will have polices and roles - which will make use of the auth type ,JWT to authenticate with Terraform cloud to provide dynamic aws credentials for terraform to build infrastructure in aws.
- Create AWS role and Policy - this will be used to map the access rights for the dynamic credentials generated by Vault during runtime (i.e when workspaces invoke vault)
- Create an S3 bucket to handle terraform state file.
- Create a Terraform workspace with the required set of variables - to faciliate aws dynamic credential generation upon integrating with vault. The creation of terraform workspace is handled by the terraform code.
- All code block will have an variable named "environment" - which helps us to scale the entire infra (including vault namespace) for multiple environments.

#### Deploying WebApp
Repo link : https://gitlab.com/vineethbhargavan/terraform_vault_aws/aws_lambda_spa.git
##### Implementation Notes:
- All code block will have an variable named "environment" - which helps us to scale the entire infra for multiple environments.
- Loadbalancing and selfhealing are provided by virtue of having API Gateway and Lambda.
- Lambda is mounted in a VPC - Private Subnet.
- A private S3 bucket is used to zip the artifact of lambda function 
- The same s3 bucket is used to store an Image file which will be used to render an Image in the HTML content.
###### Outline of How the Image file is accessed in Lambda Function
- Since the bucket hosting the image is a private bucket , IAM policy permitting the lambda function to access the bucket object is created to ensure smooth access.
- The image is then converted to a signed URL so that the URL can be rendered without any access issues.
###### Outline of How the Lambda function is hosted in a VPC.
To faciliate Lambda in a VPC , the following had to be done:
- VPC with two subnets , Private and Public
- NAT gateway to help with the routing for components in Private subnet.
- Internet gateway to communicate to other services like s3.
- Routing to faciliate interaction between subnets.
- IAM policy to faciliate Lambda to fit within VPC- refer code for more details on this.



## Challenges
- Operation failed: failed authenticating to Vault: Error making API request.

Namespace: admin/devsbs
URL: PUT https://vineeth-vault-cluster-public-vault-4855bb09.062a2ed3.z1.hashicorp.cloud:8200/v1/auth/jwt/login
Code: 400. Errors:

* error validating claims: claim "sub" does not match any associated bound claim values
- This was because the project name was set to SBS instead of sbs.  To avoid such errors , would be ideal to create the project using terraform script (like the workspace!)


--terraform inti migtation issues...
Had to change the token value in ~/.terraform.d

